
_main:

;matrixclock.c,80 :: 		void main() {
;matrixclock.c,82 :: 		unsigned char isTimeSet = 0;    // is time set yet? (1 = set, 0 = not set)
;matrixclock.c,84 :: 		init();
	CALL       _init+0
;matrixclock.c,86 :: 		HT1632_Init();
	CALL       _HT1632_Init+0
;matrixclock.c,88 :: 		delay_ms(250);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main0:
	DECFSZ     R13+0, 1
	GOTO       L_main0
	DECFSZ     R12+0, 1
	GOTO       L_main0
	DECFSZ     R11+0, 1
	GOTO       L_main0
	NOP
	NOP
;matrixclock.c,90 :: 		isTimeSet = read_ds1307(0x08);  // Register must be read twice - must look into it. Give some time to warm up, perhaps?
	MOVLW      8
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
;matrixclock.c,91 :: 		isTimeSet = read_ds1307(0x08);
	MOVLW      8
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
;matrixclock.c,93 :: 		if (isTimeSet == 1) {// Get data from RTC while battery is installed.
	MOVF       R0+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main1
;matrixclock.c,95 :: 		hour = read_ds1307(2);
	MOVLW      2
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _hour+0
;matrixclock.c,96 :: 		minute = read_ds1307(1);
	MOVLW      1
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _minute+0
;matrixclock.c,97 :: 		HT1632_Command(BLINK_OFF);
	MOVLW      16
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,99 :: 		}
	GOTO       L_main2
L_main1:
;matrixclock.c,102 :: 		write_ds1307(0, 0b10000000);    //seconds (last MSB is clock halt)
	CLRF       FARG_write_ds1307_address+0
	MOVLW      128
	MOVWF      FARG_write_ds1307_w_data+0
	CALL       _write_ds1307+0
;matrixclock.c,103 :: 		write_ds1307(1, byte2BCD(00));  //minutes
	CLRF       FARG_byte2BCD_inputByte+0
	CALL       _byte2BCD+0
	MOVF       R0+0, 0
	MOVWF      FARG_write_ds1307_w_data+0
	MOVLW      1
	MOVWF      FARG_write_ds1307_address+0
	CALL       _write_ds1307+0
;matrixclock.c,104 :: 		write_ds1307(2, byte2BCD(00));  //hours
	CLRF       FARG_byte2BCD_inputByte+0
	CALL       _byte2BCD+0
	MOVF       R0+0, 0
	MOVWF      FARG_write_ds1307_w_data+0
	MOVLW      2
	MOVWF      FARG_write_ds1307_address+0
	CALL       _write_ds1307+0
;matrixclock.c,105 :: 		write_ds1307(0, 0b00000000);    //seconds (last MSB is clock halt)
	CLRF       FARG_write_ds1307_address+0
	CLRF       FARG_write_ds1307_w_data+0
	CALL       _write_ds1307+0
;matrixclock.c,106 :: 		HT1632_Command(BLINK_ON);
	MOVLW      18
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,108 :: 		}
L_main2:
;matrixclock.c,110 :: 		frameBufferClear();
	CALL       _frameBufferClear+0
;matrixclock.c,111 :: 		HT1632_Clear();
	CALL       _HT1632_Clear+0
;matrixclock.c,113 :: 		readTemperatureDS18B20();
	CALL       _readTemperatureDS18B20+0
;matrixclock.c,115 :: 		delay_ms(2000);                // wait for the DS18B20 to fully power up first.
	MOVLW      21
	MOVWF      R11+0
	MOVLW      75
	MOVWF      R12+0
	MOVLW      190
	MOVWF      R13+0
L_main3:
	DECFSZ     R13+0, 1
	GOTO       L_main3
	DECFSZ     R12+0, 1
	GOTO       L_main3
	DECFSZ     R11+0, 1
	GOTO       L_main3
	NOP
;matrixclock.c,117 :: 		while(1)
L_main4:
;matrixclock.c,119 :: 		frameBufferClear();
	CALL       _frameBufferClear+0
;matrixclock.c,121 :: 		hour = read_ds1307(2);
	MOVLW      2
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _hour+0
;matrixclock.c,122 :: 		minute = read_ds1307(1);
	MOVLW      1
	MOVWF      FARG_read_ds1307_address+0
	CALL       _read_ds1307+0
	MOVF       R0+0, 0
	MOVWF      _minute+0
;matrixclock.c,124 :: 		if(PORTB.RB0 == 0)
	BTFSC      PORTB+0, 0
	GOTO       L_main6
;matrixclock.c,126 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main7:
	DECFSZ     R13+0, 1
	GOTO       L_main7
	DECFSZ     R12+0, 1
	GOTO       L_main7
	NOP
	NOP
;matrixclock.c,127 :: 		hour_temp = BCD2Int(hour);
	MOVF       _hour+0, 0
	MOVWF      FARG_BCD2Int_bcd+0
	CALL       _BCD2Int+0
	MOVF       R0+0, 0
	MOVWF      _hour_temp+0
;matrixclock.c,128 :: 		hour_temp++;
	INCF       R0+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _hour_temp+0
;matrixclock.c,129 :: 		if(hour_temp > 23)
	MOVF       R1+0, 0
	SUBLW      23
	BTFSC      STATUS+0, 0
	GOTO       L_main8
;matrixclock.c,130 :: 		hour_temp = 0;
	CLRF       _hour_temp+0
L_main8:
;matrixclock.c,131 :: 		write_ds1307(2, byte2BCD(hour_temp));
	MOVF       _hour_temp+0, 0
	MOVWF      FARG_byte2BCD_inputByte+0
	CALL       _byte2BCD+0
	MOVF       R0+0, 0
	MOVWF      FARG_write_ds1307_w_data+0
	MOVLW      2
	MOVWF      FARG_write_ds1307_address+0
	CALL       _write_ds1307+0
;matrixclock.c,132 :: 		write_ds1307(0x08, 0x01);                  // time is set already
	MOVLW      8
	MOVWF      FARG_write_ds1307_address+0
	MOVLW      1
	MOVWF      FARG_write_ds1307_w_data+0
	CALL       _write_ds1307+0
;matrixclock.c,133 :: 		HT1632_Command(BLINK_OFF);
	MOVLW      16
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,134 :: 		}
L_main6:
;matrixclock.c,136 :: 		if(PORTB.RB1 == 0)
	BTFSC      PORTB+0, 1
	GOTO       L_main9
;matrixclock.c,138 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main10:
	DECFSZ     R13+0, 1
	GOTO       L_main10
	DECFSZ     R12+0, 1
	GOTO       L_main10
	NOP
	NOP
;matrixclock.c,139 :: 		minute_temp = BCD2Int(minute);
	MOVF       _minute+0, 0
	MOVWF      FARG_BCD2Int_bcd+0
	CALL       _BCD2Int+0
	MOVF       R0+0, 0
	MOVWF      _minute_temp+0
;matrixclock.c,140 :: 		minute_temp++;
	INCF       R0+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _minute_temp+0
;matrixclock.c,141 :: 		if(minute_temp > 59)
	MOVF       R1+0, 0
	SUBLW      59
	BTFSC      STATUS+0, 0
	GOTO       L_main11
;matrixclock.c,142 :: 		minute_temp = 0;
	CLRF       _minute_temp+0
L_main11:
;matrixclock.c,143 :: 		write_ds1307(1, byte2BCD(minute_temp));
	MOVF       _minute_temp+0, 0
	MOVWF      FARG_byte2BCD_inputByte+0
	CALL       _byte2BCD+0
	MOVF       R0+0, 0
	MOVWF      FARG_write_ds1307_w_data+0
	MOVLW      1
	MOVWF      FARG_write_ds1307_address+0
	CALL       _write_ds1307+0
;matrixclock.c,144 :: 		write_ds1307(0x08, 0x01);                  // time is set already
	MOVLW      8
	MOVWF      FARG_write_ds1307_address+0
	MOVLW      1
	MOVWF      FARG_write_ds1307_w_data+0
	CALL       _write_ds1307+0
;matrixclock.c,145 :: 		HT1632_Command(BLINK_OFF);
	MOVLW      16
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,146 :: 		}
L_main9:
;matrixclock.c,149 :: 		if(PORTB.RB2 == 0)
	BTFSC      PORTB+0, 2
	GOTO       L_main12
;matrixclock.c,151 :: 		delay_ms(5);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_main13:
	DECFSZ     R13+0, 1
	GOTO       L_main13
	DECFSZ     R12+0, 1
	GOTO       L_main13
	NOP
	NOP
;matrixclock.c,152 :: 		frameBufferClear();
	CALL       _frameBufferClear+0
;matrixclock.c,153 :: 		while(temp_timer < 5)
L_main14:
	MOVLW      5
	SUBWF      _temp_timer+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main15
;matrixclock.c,155 :: 		delay_ms(1000);
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main16:
	DECFSZ     R13+0, 1
	GOTO       L_main16
	DECFSZ     R12+0, 1
	GOTO       L_main16
	DECFSZ     R11+0, 1
	GOTO       L_main16
	NOP
	NOP
;matrixclock.c,156 :: 		temp_timer++;
	INCF       _temp_timer+0, 1
;matrixclock.c,157 :: 		HT1632_WriteNum(27-4, tempTens);
	MOVLW      23
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVF       _tempTens+0, 0
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,158 :: 		HT1632_WriteNum(21-4, tempOnes);
	MOVLW      17
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVF       _tempOnes+0, 0
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,159 :: 		HT1632_WriteNum(15-4, DEGREE_SYMBOL);
	MOVLW      11
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVLW      12
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,160 :: 		HT1632_WriteNum(9-4,  LATIN_C);
	MOVLW      5
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVLW      11
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,161 :: 		HT1632_DrawFrameBuffer();
	CALL       _HT1632_DrawFrameBuffer+0
;matrixclock.c,162 :: 		}
	GOTO       L_main14
L_main15:
;matrixclock.c,163 :: 		temp_timer = 0;
	CLRF       _temp_timer+0
;matrixclock.c,164 :: 		frameBufferClear();
	CALL       _frameBufferClear+0
;matrixclock.c,165 :: 		}
L_main12:
;matrixclock.c,167 :: 		time[0] = BCD2UpperInt(hour);
	MOVF       _hour+0, 0
	MOVWF      FARG_BCD2UpperInt_bcd+0
	CALL       _BCD2UpperInt+0
	MOVF       R0+0, 0
	MOVWF      _time+0
;matrixclock.c,168 :: 		time[1] = BCD2LowerInt(hour);
	MOVF       _hour+0, 0
	MOVWF      FARG_BCD2LowerInt_bcd+0
	CALL       _BCD2LowerInt+0
	MOVF       R0+0, 0
	MOVWF      _time+1
;matrixclock.c,169 :: 		time[2] = BCD2UpperInt(minute);
	MOVF       _minute+0, 0
	MOVWF      FARG_BCD2UpperInt_bcd+0
	CALL       _BCD2UpperInt+0
	MOVF       R0+0, 0
	MOVWF      _time+2
;matrixclock.c,170 :: 		time[3] = BCD2LowerInt(minute);
	MOVF       _minute+0, 0
	MOVWF      FARG_BCD2LowerInt_bcd+0
	CALL       _BCD2LowerInt+0
	MOVF       R0+0, 0
	MOVWF      _time+3
;matrixclock.c,172 :: 		readTemperatureDS18B20();
	CALL       _readTemperatureDS18B20+0
;matrixclock.c,174 :: 		HT1632_WriteNum(27-2, time[0]);
	MOVLW      25
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVF       _time+0, 0
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,176 :: 		HT1632_WriteNum(21-2, time[1]);
	MOVLW      19
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVF       _time+1, 0
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,178 :: 		HT1632_WriteNum(15-2, 10);
	MOVLW      13
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVLW      10
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,180 :: 		HT1632_WriteNum(9-1, time[2]);
	MOVLW      8
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVF       _time+2, 0
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,182 :: 		HT1632_WriteNum(3-1, time[3]);
	MOVLW      2
	MOVWF      FARG_HT1632_WriteNum_col+0
	MOVF       _time+3, 0
	MOVWF      FARG_HT1632_WriteNum_num+0
	CALL       _HT1632_WriteNum+0
;matrixclock.c,184 :: 		HT1632_DrawFrameBuffer();
	CALL       _HT1632_DrawFrameBuffer+0
;matrixclock.c,186 :: 		delay_ms(250);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      138
	MOVWF      R12+0
	MOVLW      85
	MOVWF      R13+0
L_main17:
	DECFSZ     R13+0, 1
	GOTO       L_main17
	DECFSZ     R12+0, 1
	GOTO       L_main17
	DECFSZ     R11+0, 1
	GOTO       L_main17
	NOP
	NOP
;matrixclock.c,188 :: 		}
	GOTO       L_main4
;matrixclock.c,190 :: 		}
L_end_main:
	GOTO       $+0
; end of _main

_init:

;matrixclock.c,192 :: 		void init()
;matrixclock.c,194 :: 		ADCON0.ADON = 0;           // shut off ADC
	BCF        ADCON0+0, 0
;matrixclock.c,195 :: 		ADCON1.PCFG3 = 0;          // all pins Digital
	BCF        ADCON1+0, 3
;matrixclock.c,196 :: 		ADCON1.PCFG2 = 1;
	BSF        ADCON1+0, 2
;matrixclock.c,197 :: 		ADCON1.PCFG1 = 1;
	BSF        ADCON1+0, 1
;matrixclock.c,198 :: 		ADCON1.PCFG0 = 0;
	BCF        ADCON1+0, 0
;matrixclock.c,200 :: 		TRISC = 0x00;
	CLRF       TRISC+0
;matrixclock.c,201 :: 		TRISD = 0x00;
	CLRF       TRISD+0
;matrixclock.c,202 :: 		TRISB.RB0 = 1;
	BSF        TRISB+0, 0
;matrixclock.c,203 :: 		TRISB.RB1 = 1;
	BSF        TRISB+0, 1
;matrixclock.c,204 :: 		TRISB.RB2 = 1;
	BSF        TRISB+0, 2
;matrixclock.c,206 :: 		OPTION_REG.INTEDG = 0; // falling edge interrupt
	BCF        OPTION_REG+0, 6
;matrixclock.c,207 :: 		INTCON.INTE = 0;       // disable external interrupt at RB0
	BCF        INTCON+0, 4
;matrixclock.c,208 :: 		INTCON.PEIE = 0;
	BCF        INTCON+0, 6
;matrixclock.c,209 :: 		INTCON.GIE = 0;        // disable all interrupts here
	BCF        INTCON+0, 7
;matrixclock.c,210 :: 		INTCON.INTF = 0;       // clear external interrupt flag
	BCF        INTCON+0, 1
;matrixclock.c,213 :: 		I2C1_Init(100000);
	MOVLW      20
	MOVWF      SSPADD+0
	CALL       _I2C1_Init+0
;matrixclock.c,214 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;matrixclock.c,216 :: 		}
L_end_init:
	RETURN
; end of _init

_HT1632_Command:

;matrixclock.c,218 :: 		void HT1632_Command(unsigned int command)
;matrixclock.c,224 :: 		CS1 = 1;
	BSF        PORTD+0, 0
;matrixclock.c,225 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,227 :: 		j = command << 4;
	MOVF       FARG_HT1632_Command_command+0, 0
	MOVWF      R0+0
	MOVF       FARG_HT1632_Command_command+1, 0
	MOVWF      R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
;matrixclock.c,229 :: 		regAMSB = 0b1000000000000000 | j;
	MOVLW      0
	IORWF      R0+0, 0
	MOVWF      R4+0
	MOVF       R0+1, 0
	IORLW      128
	MOVWF      R4+1
;matrixclock.c,231 :: 		CS1 = 0;
	BCF        PORTD+0, 0
;matrixclock.c,232 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,234 :: 		for(i=0; i<16; i++)
	CLRF       R3+0
L_HT1632_Command18:
	MOVLW      16
	SUBWF      R3+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_HT1632_Command19
;matrixclock.c,236 :: 		DATA = (regAMSB >> 15) & 0x0001;
	MOVLW      15
	MOVWF      R2+0
	MOVF       R4+0, 0
	MOVWF      R0+0
	MOVF       R4+1, 0
	MOVWF      R0+1
	MOVF       R2+0, 0
L__HT1632_Command43:
	BTFSC      STATUS+0, 2
	GOTO       L__HT1632_Command44
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+1, 7
	ADDLW      255
	GOTO       L__HT1632_Command43
L__HT1632_Command44:
	MOVLW      1
	ANDWF      R0+0, 1
	BTFSC      R0+0, 0
	GOTO       L__HT1632_Command45
	BCF        PORTD+0, 2
	GOTO       L__HT1632_Command46
L__HT1632_Command45:
	BSF        PORTD+0, 2
L__HT1632_Command46:
;matrixclock.c,237 :: 		regAMSB = regAMSB << 1;
	RLF        R4+0, 1
	RLF        R4+1, 1
	BCF        R4+0, 0
;matrixclock.c,238 :: 		CLK = 0;
	BCF        PORTD+0, 1
;matrixclock.c,239 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,240 :: 		CLK = 1;
	BSF        PORTD+0, 1
;matrixclock.c,241 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,234 :: 		for(i=0; i<16; i++)
	INCF       R3+0, 1
;matrixclock.c,242 :: 		}
	GOTO       L_HT1632_Command18
L_HT1632_Command19:
;matrixclock.c,244 :: 		CS1 = 1;
	BSF        PORTD+0, 0
;matrixclock.c,245 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,247 :: 		}
L_end_HT1632_Command:
	RETURN
; end of _HT1632_Command

_HT1632_SendData:

;matrixclock.c,249 :: 		void HT1632_SendData(unsigned char address, unsigned char inputData)
;matrixclock.c,255 :: 		CS1 = 1;
	BSF        PORTD+0, 0
;matrixclock.c,256 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,258 :: 		j = (address & 0x7F) << 6;
	MOVLW      127
	ANDWF      FARG_HT1632_SendData_address+0, 0
	MOVWF      R1+0
	MOVLW      6
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      R4+0
	CLRF       R4+1
	MOVF       R0+0, 0
L__HT1632_SendData48:
	BTFSC      STATUS+0, 2
	GOTO       L__HT1632_SendData49
	RLF        R4+0, 1
	RLF        R4+1, 1
	BCF        R4+0, 0
	ADDLW      255
	GOTO       L__HT1632_SendData48
L__HT1632_SendData49:
;matrixclock.c,259 :: 		l = (inputData & 0x000f) << 2;
	MOVLW      15
	ANDWF      FARG_HT1632_SendData_inputData+0, 0
	MOVWF      R3+0
	MOVF       R3+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
;matrixclock.c,260 :: 		regAMSB = 0b1010000000000000 | j | l;
	MOVLW      0
	IORWF      R4+0, 0
	MOVWF      R7+0
	MOVF       R4+1, 0
	IORLW      160
	MOVWF      R7+1
	MOVF       R0+0, 0
	IORWF      R7+0, 1
	MOVF       R0+1, 0
	IORWF      R7+1, 1
;matrixclock.c,262 :: 		regAMSB = regAMSB >> 2;
	RRF        R7+1, 1
	RRF        R7+0, 1
	BCF        R7+1, 7
	RRF        R7+1, 1
	RRF        R7+0, 1
	BCF        R7+1, 7
;matrixclock.c,264 :: 		CS1 = 0;
	BCF        PORTD+0, 0
;matrixclock.c,265 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,267 :: 		for(i=0; i<14; i++)
	CLRF       R6+0
L_HT1632_SendData21:
	MOVLW      14
	SUBWF      R6+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_HT1632_SendData22
;matrixclock.c,269 :: 		DATA = (regAMSB >> 13) & 0x0001;
	MOVLW      13
	MOVWF      R2+0
	MOVF       R7+0, 0
	MOVWF      R0+0
	MOVF       R7+1, 0
	MOVWF      R0+1
	MOVF       R2+0, 0
L__HT1632_SendData50:
	BTFSC      STATUS+0, 2
	GOTO       L__HT1632_SendData51
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+1, 7
	ADDLW      255
	GOTO       L__HT1632_SendData50
L__HT1632_SendData51:
	MOVLW      1
	ANDWF      R0+0, 1
	BTFSC      R0+0, 0
	GOTO       L__HT1632_SendData52
	BCF        PORTD+0, 2
	GOTO       L__HT1632_SendData53
L__HT1632_SendData52:
	BSF        PORTD+0, 2
L__HT1632_SendData53:
;matrixclock.c,270 :: 		regAMSB = regAMSB << 1;
	RLF        R7+0, 1
	RLF        R7+1, 1
	BCF        R7+0, 0
;matrixclock.c,271 :: 		CLK = 0;
	BCF        PORTD+0, 1
;matrixclock.c,272 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,273 :: 		CLK = 1;
	BSF        PORTD+0, 1
;matrixclock.c,274 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,267 :: 		for(i=0; i<14; i++)
	INCF       R6+0, 1
;matrixclock.c,275 :: 		}
	GOTO       L_HT1632_SendData21
L_HT1632_SendData22:
;matrixclock.c,277 :: 		CS1 = 1;
	BSF        PORTD+0, 0
;matrixclock.c,278 :: 		delay_us(1);
	NOP
	NOP
;matrixclock.c,280 :: 		}
L_end_HT1632_SendData:
	RETURN
; end of _HT1632_SendData

_HT1632_WriteNum:

;matrixclock.c,282 :: 		void HT1632_WriteNum(unsigned char col, unsigned char num)
;matrixclock.c,287 :: 		for(i = 0; i < 5; i++)
	CLRF       HT1632_WriteNum_i_L0+0
L_HT1632_WriteNum24:
	MOVLW      5
	SUBWF      HT1632_WriteNum_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_HT1632_WriteNum25
;matrixclock.c,288 :: 		frameBuffer[col+i] |= font5x7[num*5 + i];
	MOVF       HT1632_WriteNum_i_L0+0, 0
	ADDWF      FARG_HT1632_WriteNum_col+0, 0
	MOVWF      R0+0
	CLRF       R0+1
	BTFSC      STATUS+0, 0
	INCF       R0+1, 1
	MOVF       R0+0, 0
	ADDLW      _frameBuffer+0
	MOVWF      FLOC__HT1632_WriteNum+0
	MOVF       FARG_HT1632_WriteNum_num+0, 0
	MOVWF      R0+0
	MOVLW      5
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       HT1632_WriteNum_i_L0+0, 0
	ADDWF      R0+0, 1
	BTFSC      STATUS+0, 0
	INCF       R0+1, 1
	MOVF       R0+0, 0
	ADDLW      _font5x7+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       FLOC__HT1632_WriteNum+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	IORWF      R0+0, 1
	MOVF       FLOC__HT1632_WriteNum+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;matrixclock.c,287 :: 		for(i = 0; i < 5; i++)
	INCF       HT1632_WriteNum_i_L0+0, 1
;matrixclock.c,288 :: 		frameBuffer[col+i] |= font5x7[num*5 + i];
	GOTO       L_HT1632_WriteNum24
L_HT1632_WriteNum25:
;matrixclock.c,290 :: 		}
L_end_HT1632_WriteNum:
	RETURN
; end of _HT1632_WriteNum

_HT1632_DrawFrameBuffer:

;matrixclock.c,292 :: 		void HT1632_DrawFrameBuffer()
;matrixclock.c,297 :: 		for(i = 0; i < 32; i++)
	CLRF       HT1632_DrawFrameBuffer_i_L0+0
L_HT1632_DrawFrameBuffer27:
	MOVLW      32
	SUBWF      HT1632_DrawFrameBuffer_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_HT1632_DrawFrameBuffer28
;matrixclock.c,298 :: 		HT1632_SendData(2*i,   (frameBuffer[i] >> 4) & 0x0f);
	MOVF       HT1632_DrawFrameBuffer_i_L0+0, 0
	MOVWF      FARG_HT1632_SendData_address+0
	RLF        FARG_HT1632_SendData_address+0, 1
	BCF        FARG_HT1632_SendData_address+0, 0
	MOVF       HT1632_DrawFrameBuffer_i_L0+0, 0
	ADDLW      _frameBuffer+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      FARG_HT1632_SendData_inputData+0
	RRF        FARG_HT1632_SendData_inputData+0, 1
	BCF        FARG_HT1632_SendData_inputData+0, 7
	RRF        FARG_HT1632_SendData_inputData+0, 1
	BCF        FARG_HT1632_SendData_inputData+0, 7
	RRF        FARG_HT1632_SendData_inputData+0, 1
	BCF        FARG_HT1632_SendData_inputData+0, 7
	RRF        FARG_HT1632_SendData_inputData+0, 1
	BCF        FARG_HT1632_SendData_inputData+0, 7
	MOVLW      15
	ANDWF      FARG_HT1632_SendData_inputData+0, 1
	CALL       _HT1632_SendData+0
;matrixclock.c,297 :: 		for(i = 0; i < 32; i++)
	INCF       HT1632_DrawFrameBuffer_i_L0+0, 1
;matrixclock.c,298 :: 		HT1632_SendData(2*i,   (frameBuffer[i] >> 4) & 0x0f);
	GOTO       L_HT1632_DrawFrameBuffer27
L_HT1632_DrawFrameBuffer28:
;matrixclock.c,300 :: 		for(i = 0; i < 32; i++)
	CLRF       HT1632_DrawFrameBuffer_i_L0+0
L_HT1632_DrawFrameBuffer30:
	MOVLW      32
	SUBWF      HT1632_DrawFrameBuffer_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_HT1632_DrawFrameBuffer31
;matrixclock.c,301 :: 		HT1632_SendData(2*i+1, frameBuffer[i] & 0x0f);
	MOVF       HT1632_DrawFrameBuffer_i_L0+0, 0
	MOVWF      FARG_HT1632_SendData_address+0
	RLF        FARG_HT1632_SendData_address+0, 1
	BCF        FARG_HT1632_SendData_address+0, 0
	INCF       FARG_HT1632_SendData_address+0, 1
	MOVF       HT1632_DrawFrameBuffer_i_L0+0, 0
	ADDLW      _frameBuffer+0
	MOVWF      FSR
	MOVLW      15
	ANDWF      INDF+0, 0
	MOVWF      FARG_HT1632_SendData_inputData+0
	CALL       _HT1632_SendData+0
;matrixclock.c,300 :: 		for(i = 0; i < 32; i++)
	INCF       HT1632_DrawFrameBuffer_i_L0+0, 1
;matrixclock.c,301 :: 		HT1632_SendData(2*i+1, frameBuffer[i] & 0x0f);
	GOTO       L_HT1632_DrawFrameBuffer30
L_HT1632_DrawFrameBuffer31:
;matrixclock.c,303 :: 		}
L_end_HT1632_DrawFrameBuffer:
	RETURN
; end of _HT1632_DrawFrameBuffer

_HT1632_Init:

;matrixclock.c,305 :: 		void HT1632_Init()
;matrixclock.c,308 :: 		HT1632_Command(SYS_EN);
	MOVLW      2
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,309 :: 		HT1632_Command(LED_ON);
	MOVLW      6
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,310 :: 		HT1632_Command(RC_MASTER_MODE);
	MOVLW      48
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,311 :: 		HT1632_Command(N_MOS_COM8);
	MOVLW      64
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,312 :: 		HT1632_Command(PWM_16);
	MOVLW      94
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      1
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,313 :: 		HT1632_Command(BLINK_OFF);
	MOVLW      16
	MOVWF      FARG_HT1632_Command_command+0
	MOVLW      0
	MOVWF      FARG_HT1632_Command_command+1
	CALL       _HT1632_Command+0
;matrixclock.c,315 :: 		}
L_end_HT1632_Init:
	RETURN
; end of _HT1632_Init

_frameBufferClear:

;matrixclock.c,317 :: 		void frameBufferClear()
;matrixclock.c,319 :: 		unsigned char i = 0;
	CLRF       frameBufferClear_i_L0+0
;matrixclock.c,321 :: 		for(i = 0; i < 32; i++)
	CLRF       frameBufferClear_i_L0+0
L_frameBufferClear33:
	MOVLW      32
	SUBWF      frameBufferClear_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_frameBufferClear34
;matrixclock.c,322 :: 		frameBuffer[i] = 0x00;
	MOVF       frameBufferClear_i_L0+0, 0
	ADDLW      _frameBuffer+0
	MOVWF      FSR
	CLRF       INDF+0
;matrixclock.c,321 :: 		for(i = 0; i < 32; i++)
	INCF       frameBufferClear_i_L0+0, 1
;matrixclock.c,322 :: 		frameBuffer[i] = 0x00;
	GOTO       L_frameBufferClear33
L_frameBufferClear34:
;matrixclock.c,324 :: 		}
L_end_frameBufferClear:
	RETURN
; end of _frameBufferClear

_HT1632_Clear:

;matrixclock.c,326 :: 		void HT1632_Clear()
;matrixclock.c,329 :: 		unsigned char i = 0;
	CLRF       HT1632_Clear_i_L0+0
;matrixclock.c,331 :: 		for(i = 0; i < 64; i++)
	CLRF       HT1632_Clear_i_L0+0
L_HT1632_Clear36:
	MOVLW      64
	SUBWF      HT1632_Clear_i_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_HT1632_Clear37
;matrixclock.c,332 :: 		HT1632_SendData(i, 0x00);
	MOVF       HT1632_Clear_i_L0+0, 0
	MOVWF      FARG_HT1632_SendData_address+0
	CLRF       FARG_HT1632_SendData_inputData+0
	CALL       _HT1632_SendData+0
;matrixclock.c,331 :: 		for(i = 0; i < 64; i++)
	INCF       HT1632_Clear_i_L0+0, 1
;matrixclock.c,332 :: 		HT1632_SendData(i, 0x00);
	GOTO       L_HT1632_Clear36
L_HT1632_Clear37:
;matrixclock.c,334 :: 		}
L_end_HT1632_Clear:
	RETURN
; end of _HT1632_Clear

_readTemperatureDS18B20:

;matrixclock.c,336 :: 		void readTemperatureDS18B20()
;matrixclock.c,339 :: 		Ow_Reset(&PORTA, 0);
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Reset_port+0
	CLRF       FARG_Ow_Reset_pin+0
	CALL       _Ow_Reset+0
;matrixclock.c,340 :: 		Ow_Write(&PORTA, 0, 0xCC);                   // Issue command SKIP_ROM
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	CLRF       FARG_Ow_Write_pin+0
	MOVLW      204
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;matrixclock.c,341 :: 		Ow_Write(&PORTA, 0, 0x44);                   // Issue command CONVERT_T
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	CLRF       FARG_Ow_Write_pin+0
	MOVLW      68
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;matrixclock.c,343 :: 		delay_us(120);
	MOVLW      79
	MOVWF      R13+0
L_readTemperatureDS18B2039:
	DECFSZ     R13+0, 1
	GOTO       L_readTemperatureDS18B2039
	NOP
	NOP
;matrixclock.c,345 :: 		Ow_Reset(&PORTA, 0);
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Reset_port+0
	CLRF       FARG_Ow_Reset_pin+0
	CALL       _Ow_Reset+0
;matrixclock.c,346 :: 		Ow_Write(&PORTA, 0, 0xCC);                   // Issue command SKIP_ROM
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	CLRF       FARG_Ow_Write_pin+0
	MOVLW      204
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;matrixclock.c,347 :: 		Ow_Write(&PORTA, 0, 0xBE);                   // Issue command READ_SCRATCHPAD
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Write_port+0
	CLRF       FARG_Ow_Write_pin+0
	MOVLW      190
	MOVWF      FARG_Ow_Write_data_+0
	CALL       _Ow_Write+0
;matrixclock.c,349 :: 		scratchPadTemp[0] = Ow_Read(&PORTA, 0);      // LSB
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Read_port+0
	CLRF       FARG_Ow_Read_pin+0
	CALL       _Ow_Read+0
	MOVF       R0+0, 0
	MOVWF      _scratchPadTemp+0
;matrixclock.c,350 :: 		scratchPadTemp[1] = Ow_Read(&PORTA, 0);      // MSB
	MOVLW      PORTA+0
	MOVWF      FARG_Ow_Read_port+0
	CLRF       FARG_Ow_Read_pin+0
	CALL       _Ow_Read+0
	MOVF       R0+0, 0
	MOVWF      _scratchPadTemp+1
;matrixclock.c,352 :: 		scratchpadTemp[0] = 0b11110000 & scratchpadTemp[0];
	MOVLW      240
	ANDWF      _scratchPadTemp+0, 1
;matrixclock.c,353 :: 		scratchpadTemp[1] = 0b00000111 & scratchpadTemp[1];
	MOVLW      7
	ANDWF      _scratchPadTemp+1, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _scratchPadTemp+1
;matrixclock.c,355 :: 		tempByte = (scratchpadTemp[1] << 4) | (scratchpadTemp[0] >> 4);
	MOVF       R1+0, 0
	MOVWF      R2+0
	RLF        R2+0, 1
	BCF        R2+0, 0
	RLF        R2+0, 1
	BCF        R2+0, 0
	RLF        R2+0, 1
	BCF        R2+0, 0
	RLF        R2+0, 1
	BCF        R2+0, 0
	MOVF       _scratchPadTemp+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _tempByte+0
;matrixclock.c,357 :: 		tempTens = tempByte / 10;
	MOVLW      10
	MOVWF      R4+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      _tempTens+0
;matrixclock.c,358 :: 		tempOnes = tempByte % 10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       _tempByte+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _tempOnes+0
;matrixclock.c,360 :: 		}
L_end_readTemperatureDS18B20:
	RETURN
; end of _readTemperatureDS18B20

_BCD2UpperInt:

;matrixclock.c,363 :: 		unsigned char BCD2UpperInt(unsigned char bcd) {
;matrixclock.c,364 :: 		return (bcd & 0xf0) >> 4;
	MOVLW      240
	ANDWF      FARG_BCD2UpperInt_bcd+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
;matrixclock.c,365 :: 		}
L_end_BCD2UpperInt:
	RETURN
; end of _BCD2UpperInt

_BCD2LowerInt:

;matrixclock.c,367 :: 		unsigned char BCD2LowerInt(unsigned char bcd) {
;matrixclock.c,368 :: 		return ((bcd & 0x0F));
	MOVLW      15
	ANDWF      FARG_BCD2LowerInt_bcd+0, 0
	MOVWF      R0+0
;matrixclock.c,369 :: 		}
L_end_BCD2LowerInt:
	RETURN
; end of _BCD2LowerInt

_byte2BCD:

;matrixclock.c,371 :: 		unsigned char byte2BCD(unsigned char inputByte) {
;matrixclock.c,374 :: 		tens = inputByte / 10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_byte2BCD_inputByte+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      byte2BCD_tens_L0+0
;matrixclock.c,375 :: 		ones = inputByte % 10;
	MOVLW      10
	MOVWF      R4+0
	MOVF       FARG_byte2BCD_inputByte+0, 0
	MOVWF      R0+0
	CALL       _Div_8x8_U+0
	MOVF       R8+0, 0
	MOVWF      R0+0
;matrixclock.c,377 :: 		BCDresult = ((tens & 0x0f) << 4) | (ones & 0x0f);
	MOVLW      15
	ANDWF      byte2BCD_tens_L0+0, 0
	MOVWF      R3+0
	MOVF       R3+0, 0
	MOVWF      R1+0
	RLF        R1+0, 1
	BCF        R1+0, 0
	RLF        R1+0, 1
	BCF        R1+0, 0
	RLF        R1+0, 1
	BCF        R1+0, 0
	RLF        R1+0, 1
	BCF        R1+0, 0
	MOVLW      15
	ANDWF      R0+0, 1
	MOVF       R1+0, 0
	IORWF      R0+0, 1
;matrixclock.c,379 :: 		return BCDresult;
;matrixclock.c,380 :: 		}
L_end_byte2BCD:
	RETURN
; end of _byte2BCD

_BCD2Int:

;matrixclock.c,382 :: 		unsigned char BCD2Int(unsigned char bcd) {
;matrixclock.c,383 :: 		return ((BCD2UpperInt(bcd) * 10) + BCD2LowerInt(bcd));
	MOVF       FARG_BCD2Int_bcd+0, 0
	MOVWF      FARG_BCD2UpperInt_bcd+0
	CALL       _BCD2UpperInt+0
	MOVLW      10
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	MOVWF      FLOC__BCD2Int+0
	MOVF       FARG_BCD2Int_bcd+0, 0
	MOVWF      FARG_BCD2LowerInt_bcd+0
	CALL       _BCD2LowerInt+0
	MOVF       FLOC__BCD2Int+0, 0
	ADDWF      R0+0, 1
;matrixclock.c,384 :: 		}
L_end_BCD2Int:
	RETURN
; end of _BCD2Int

_write_ds1307:

;matrixclock.c,386 :: 		void write_ds1307(unsigned short address,unsigned short w_data)
;matrixclock.c,388 :: 		I2C1_Start(); // issue I2C start signal
	CALL       _I2C1_Start+0
;matrixclock.c,390 :: 		I2C1_Wr(0xD0); // send byte via I2C (device address + W)
	MOVLW      208
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;matrixclock.c,391 :: 		I2C1_Wr(address); // send byte (address of DS1307 location)
	MOVF       FARG_write_ds1307_address+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;matrixclock.c,392 :: 		I2C1_Wr(w_data); // send data (data to be written)
	MOVF       FARG_write_ds1307_w_data+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;matrixclock.c,393 :: 		I2C1_Stop(); // issue I2C stop signal
	CALL       _I2C1_Stop+0
;matrixclock.c,394 :: 		}
L_end_write_ds1307:
	RETURN
; end of _write_ds1307

_read_ds1307:

;matrixclock.c,396 :: 		unsigned short read_ds1307(unsigned short address)
;matrixclock.c,400 :: 		I2C1_Start();
	CALL       _I2C1_Start+0
;matrixclock.c,401 :: 		I2C1_Wr(0xd0); //address 0x68 followed by direction bit (0 for write, 1 for read) 0x68 followed by 0 --> 0xD0
	MOVLW      208
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;matrixclock.c,402 :: 		I2C1_Wr(address);
	MOVF       FARG_read_ds1307_address+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;matrixclock.c,403 :: 		I2C1_Repeated_Start();
	CALL       _I2C1_Repeated_Start+0
;matrixclock.c,404 :: 		I2C1_Wr(0xd1); //0x68 followed by 1 --> 0xD1
	MOVLW      209
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;matrixclock.c,405 :: 		readData=I2C1_Rd(0);
	CLRF       FARG_I2C1_Rd_ack+0
	CALL       _I2C1_Rd+0
	MOVF       R0+0, 0
	MOVWF      read_ds1307_readData_L0+0
;matrixclock.c,406 :: 		I2C1_Stop();
	CALL       _I2C1_Stop+0
;matrixclock.c,407 :: 		return readData;
	MOVF       read_ds1307_readData_L0+0, 0
	MOVWF      R0+0
;matrixclock.c,408 :: 		}
L_end_read_ds1307:
	RETURN
; end of _read_ds1307
